#include <stdio.h>
#include <string.h>
#define MAX 2048
#define MAX2 1000000
typedef enum { BOOL, OSOBA, INDIR, QUANT, DISJ, KONJ } typt;
struct vyrok { 
 typt typ;
 union {
  int B;
  struct { 
   int kdo;
   int co;
   } O;
  struct {
   int kdo;
   int hodn;
   int co;
   } I;
  struct {
   int vice;
   int kolik;
   } Q;
  struct {
   int co1;
   int co2;
   } D;
  struct {
   int co1;
   int co2;
   } K;
  } U;
 };
struct ohodn {
 int maska;
 int hodn[MAX];
 };
struct vyrok pole[MAX2];
char buf[MAX];
int pbuf;
int vyroky[MAX];
int autori[MAX];
struct ohodn hodnota[MAX];
int vyroku,vpoli,zadani,pocitadlo;
char jmena[16][MAX];
int jmen;
int moznosti0,moznosti1,vyhodit,okay;
int scmp(char *c,char *d) {
 while ((*c==*d)&&*c) c++,d++;
 return (!*d);
 }
int getname() {
 int i;
 for (i=0; i<jmen; i++)
  if (scmp(buf,jmena[i])) 
  { pbuf+=strlen(jmena[i]); return i; }
 if (scmp(buf,"Poctivcu")) 
  { pbuf+=8; return -1; }
 if (scmp(buf,"Lharu"))
  { pbuf+=5; return -2; }
 return -3;
 }
int nacticislo() {
 int v;
 for (v=0; (buf[pbuf]>='0') && (buf[pbuf]<='9') ;pbuf++) v=v*10+(buf[pbuf]-'0');
 return v;
 }
void nacti() {
 int i,j,k,l;
 k=vpoli++;
 switch(buf[pbuf]) {
  case '(':
    pbuf++;
    nacti();
    pbuf+=2;
    if (buf[pbuf]=='a') {
     pbuf+=11;
     pole[k].typ=KONJ;
     pole[k].U.K.co1=k+1;
     pole[k].U.K.co2=vpoli;
     }
    else {
     pbuf+=6;
     pole[k].typ=DISJ;
     pole[k].U.D.co1=k+1;
     pole[k].U.D.co2=vpoli;
     }
    nacti();
    pbuf++;
    break;
  case '0':
  case '1':
  case '2':
  case '3':
  case '4':
  case '5':
  case '6':
  case '7':
  case '8':
  case '9':
    i=nacticislo();
    pbuf+=3;
    j=nacticislo();
    pbuf+=3;
    l=nacticislo();
    pole[k].typ=BOOL;
    pole[k].U.B=((i+j)==l);
    break;
  default:
    l=getname();
    switch (l) {
    case -1:
    case -2:  
      pole[k].typ=QUANT;
      pbuf+=4;
      switch (buf[pbuf]) {
      case 'a':
        pbuf+=8;
        pole[k].U.Q.vice=1;
        pole[k].U.Q.kolik=nacticislo()-1;
        break;
      case 'v':
        pbuf+=9;
        pole[k].U.Q.vice=1;
        pole[k].U.Q.kolik=nacticislo();
        break;
      case 'm':
        pbuf+=9;
        pole[k].U.Q.vice=0;
        pole[k].U.Q.kolik=nacticislo()-1;
        break;
      }      
      if (l==-2) {
       pole[k].U.Q.vice=!pole[k].U.Q.vice;
       pole[k].U.Q.kolik=jmen-pole[k].U.Q.kolik;
       } 
      break;
    default:
      if (buf[++pbuf]=='j') {
       pbuf+=3;
       pole[k].typ=OSOBA;
       pole[k].U.O.kdo=l;
       if (buf[pbuf]=='p') {
        pole[k].U.O.co=1;
        pbuf+=8;
        }
       else {
        pole[k].U.O.co=0;
        pbuf+=4;
        }
       }
      else {
       pbuf+=6;
       nacti();
       pbuf++;
       pole[k].typ=INDIR;
       pole[k].U.I.kdo=l;
       pole[k].U.I.co=k+1;
       switch (buf[pbuf]) {
        case '.':
          pole[k].U.I.hodn=-1;
          pbuf+=1;
          break;
        case ' ':
          pole[k].U.I.hodn=1;
          pbuf+=20;
          break;
        case ',':
          pole[k].U.I.hodn=0;
          pbuf+=20;
          break;
        }
       }
    }
  }
 }
int jednicky(int p) {
 int q;
 for (q=1; --p; ) q=(q<<1)|1;
 return q;
 }
int jednicek(int p) {
 int q;
 for (q=0; p; p>>=1) if (p&1) q++;
 return q;
 }
int vygener(int m,int i) {
 int v;
 for (v=0; m; m>>=1)
  if (m&1) {
   v=(v<<1)&(i&1);
   i>>=1;
   }
 return v;
 }
void ohodnot(struct ohodn *p,int q) {
 struct ohodn s1;
 struct ohodn s2;
 int i,j,k,l;
 switch(pole[q].typ) {
  case BOOL:
    p->maska=0;
    p->hodn[0]=pole[q].U.B;
    break;
  case OSOBA:
    p->maska=1<<pole[q].U.O.kdo;
    p->hodn[0]=!pole[q].U.O.co;
    p->hodn[p->maska]=pole[q].U.O.co;
    break;
  case INDIR:
    ohodnot(&s1,pole[q].U.I.co);
    l=1<<pole[q].U.I.kdo;
    p->maska=s1.maska|l;
    j=jednicky(jednicek(p->maska));
    for (i=0; i<=j; i++) {
     k=vygener(p->maska,i);
     switch (pole[q].U.I.hodn) {
      case -1:
        p->hodn[k]=(k&l)?s1.hodn[k&s1.maska]:!s1.hodn[k&s1.maska];
        break;
      case 0:
        p->hodn[k]=(!(k&l))&&(!s1.hodn[k&s1.maska]);
        break;
      case 1:
        p->hodn[k]=(k&l)&&s1.hodn[k&s1.maska];
        break;
      }
     }
    break;
  case QUANT:
    p->maska=jednicky(jmen);
    j=pole[q].U.Q.kolik;
    l=pole[q].U.Q.vice;
    for (i=0; i<=p->maska; i++)
     if (l)
      p->hodn[i]=(jednicek(i)>j);
     else
      p->hodn[i]=(jednicek(i)<=j);
    break;
  case DISJ:
    ohodnot(&s1,pole[q].U.D.co1); 
    ohodnot(&s2,pole[q].U.D.co2); 
    p->maska=s1.maska|s2.maska;
    j=jednicky(jednicek(p->maska));
    for (i=0; i<=j; i++) {
     k=vygener(p->maska,i);
     p->hodn[i]=s1.hodn[i&s1.maska]||s2.hodn[i&s2.maska];
     }
    break;
  case KONJ:
    ohodnot(&s1,pole[q].U.D.co1); 
    ohodnot(&s2,pole[q].U.D.co2); 
    p->maska=s1.maska|s2.maska;
    j=jednicky(jednicek(p->maska));
    for (i=0; i<=j; i++) {
     k=vygener(p->maska,i);
     p->hodn[i]=s1.hodn[i&s1.maska]&&s2.hodn[i&s2.maska];
     }
    break;
  }
 }
int konfl[MAX];
int konflmaska[MAX];
int i,j,k,l,m,n;

int main() {
 gets(buf);
 sscanf(buf,"%d",&zadani);
 for (pocitadlo=1; zadani--; pocitadlo++) {
  gets(buf);
  gets(buf);
  sscanf(buf,"%d",&jmen);
  for (i=0; i<jmen; i++) gets(jmena[i]);
  gets(buf);
  sscanf(buf,"%d",&vyroku);
  vpoli=0;  
  for (m=0; m<vyroku; m++) {
   gets(buf);
   pbuf=0;
   vyroky[i]=vpoli;
   autori[i]=getname();
   pbuf+=2;
   nacti();
   }
  for (m=0; m<vyroku; m++) ohodnot(&(hodnota[m]),vyroky[m]);  
  moznosti1=moznosti0=k=jednicky(jmen);   
  okay=0;
  vyhodit=0;
  for (n=0; n<=k; n++) {
   konfl[n]=0;
   konflmaska[n]=0;
   for (m=0; m<vyroku; m++) {
    l=((1<<autori[m])&n)?
      hodnota[m].hodn[n&hodnota[m].maska]:
      !hodnota[m].hodn[n&hodnota[m].maska];
    if (!l) {
     if (!(konflmaska[n]&(1<<autori[m]))) {
      konflmaska[n]|=(1<<autori[m]);
      konfl[n]++;
      }
     }
    }
   if (!konfl[n]) {
    moznosti1=moznosti1&n;
    moznosti0=moznosti0&~n;
    okay=1;
    }
   if (konfl[n]==1) {
    vyhodit=vyhodit|konflmaska[n];
    }
   /* printf("@@_%d\n",moznosti0);
    printf("@@_%d\n",moznosti1); */
   }
  printf("Hra cislo %d:\n",pocitadlo);
  if (okay)
   if (moznosti1||moznosti0)
    for (i=0; i<jmen; i++) {
     if (moznosti1&(1<<i)) printf("%s je poctivec.\n",jmena[i]);
     if (moznosti0&(1<<i)) printf("%s je lhar.\n",jmena[i]);
     }
   else
    printf("Neda se nic zjistit.\n"); 
  else
   if (vyhodit)
    if (jednicek(vyhodit)==1) {
     for (i=0; i<jmen; i++)
      if (vyhodit&(1<<i)) printf("%s prohral.\n",jmena[i]);
     }
    else {
     printf("Prohral nektery z techto hracu:");
     l=0;
     for (i=0; i<jmen; i++)
      if (vyhodit&(1<<i))
       if (l)
        printf(", %s",jmena[i]);
       else {
        l=1;
        printf(" %s",jmena[i]);
        }
     printf(".\n");
     }
   else
    printf("Pravidla porusilo vice hracu.\n");
  printf("\n");
  }
 return 0;
 }   
